(
	function()
	{
		"use strict"

		var oPresenter

		oPresenter =
		{
			/*
			   ###    ######## ######## ########  #### ########  ##     ## ######## ########  ######
			  ## ##      ##       ##    ##     ##  ##  ##     ## ##     ##    ##    ##       ##    ##
			 ##   ##     ##       ##    ##     ##  ##  ##     ## ##     ##    ##    ##       ##
			##     ##    ##       ##    ########   ##  ########  ##     ##    ##    ######    ######
			#########    ##       ##    ##   ##    ##  ##     ## ##     ##    ##    ##             ##
			##     ##    ##       ##    ##    ##   ##  ##     ## ##     ##    ##    ##       ##    ##
			##     ##    ##       ##    ##     ## #### ########   #######     ##    ########  ######
			*/
			// <editor-fold attributes>
			sDisplayId:	null,
			sLanguage: null,

			oSlider:	null,

			oElements:
			{
				eActions:	null,
				eLogo:	null,
				eQrCode:	null,
				eTime:	null,
				eWebSocketStatus:	null,
			},
			oWebSocket:
			{
				sUri: "",
				oSocket: null,
			},
			// </editor-fold>
			/*
			  ###  ######         ##  ######  ###   ######## ######## ######## ######## ########
			 ##   ##    ##       ##  ##    ##   ##  ##          ##       ##    ##       ##     ##
			##    ##            ##   ##          ## ##          ##       ##    ##       ##     ##
			##    ##   ####    ##     ######     ## ######      ##       ##    ######   ########
			##    ##    ##    ##           ##    ## ##          ##       ##    ##       ##   ##
			 ##   ##    ##   ##      ##    ##   ##  ##          ##       ##    ##       ##    ##
			  ###  ######   ##        ######  ###   ########    ##       ##    ######## ##     ##
			*/
			// <editor-fold getter/setter>
			/*
			########  ########  #### ##     ##    ###    ######## ########
			##     ## ##     ##  ##  ##     ##   ## ##      ##    ##
			########  ########   ##  ##     ## ##     ##    ##    ######
			##        ##   ##    ##   ##   ##  #########    ##    ##
			##        ##     ## ####    ###    ##     ##    ##    ########
			*/
			// <editor-fold private>
			_element: function(sElement, eElement)
			{
				sElement = "e" + sElement[0].toUpperCase() + sElement.slice(1)

				if(eElement === undefined)
				{
					return this.oElements[sElement]
				}

				this.oElements[sElement] = eElement

				return this
			},
			_language: function(sLanguage)
			{
				if(sLanguage === undefined)
				{
					return this.sLanguage
				}

				this.sLanguage = sLanguage

				return this
			},
			_slider: function(oSlider)
			{
				if(oSlider === undefined)
				{
					return this.oSlider
				}

				this.oSlider = oSlider

				return this
			},
			_websocket: function(sUri)
			{

				if(sUri === undefined)
				{
					return this.oWebSocket.oSocket
				}

				if(sUri === null)
				{
					sUri = sUri || ("wss://" + window.location.hostname + ":33371/wss_display")
				}
				if(this.oWebSocket.oSocket !== null)
				{
					this.oWebSocket.oSocket	.removeEventListener("close"	, this.onWebSocketClosed	)
					this.oWebSocket.oSocket	.removeEventListener("message"	, this.onWebSocketMessage	)
					this.oWebSocket.oSocket	.removeEventListener("open"	, this.onWebSocketOpen	)
				}

				this.oWebSocket.oSocket	= new WebSocket(sUri)

				this.oWebSocket.sUri	= sUri

				this.oWebSocket.oSocket	.addEventListener("close"	, this.onWebSocketClosed	)
				this.oWebSocket.oSocket	.addEventListener("message"	, this.onWebSocketMessage	)
				this.oWebSocket.oSocket	.addEventListener("open"	, this.onWebSocketOpen	)

				return this
			},
			// </editor-fold>
			/*
			########  ##     ## ########  ##       ####  ######
			##     ## ##     ## ##     ## ##        ##  ##
			########  ##     ## ########  ##        ##  ##
			##        ##     ## ##     ## ##        ##  ##
			##         #######  ########  ######## ####  ######
			*/
			// <editor-fold public>
			displayId: function(sDisplayId)
			{
				if(sDisplayId === undefined)
				{
					return this.sDisplayId
				}

				this.sDisplayId = sDisplayId

				return this
			},
			// </editor-fold>
			// </editor-fold>
			/*
			######## ##     ## ######## ##    ## ########  ######
			##       ##     ## ##       ###   ##    ##    ##    ##
			##       ##     ## ##       ####  ##    ##    ##
			######   ##     ## ######   ## ## ##    ##     ######
			##        ##   ##  ##       ##  ####    ##          ##
			##         ## ##   ##       ##   ###    ##    ##    ##
			########    ###    ######## ##    ##    ##     ######
			*/
			// <editor-fold events>
			onActionClicked: function(oEvent)
			{


				if(oEvent.target.id !== "actions")
				{
					oEvent.stopPropagation()
					if(oEvent.target.tagName !== "A")
					{
						let eElement

						for(eElement = oEvent.target; !eElement.parentElement.id.includes("actions"); eElement = eElement.parentElement){}
						eElement.lastElementChild.click()
					}
					else
					{
						if(oEvent.target.parentElement.id === "scan_qr_code")
						{
							this.focusQrCode()
						}
						else if(oEvent.target.parentElement.id === "language")
						{
							if ( document.getElementById('qr_engine_type').value == "hw" ) {
                                let    eQrCodeForm;

                                eQrCodeForm    = this._element("qrCode").parentElement;

                                if(this._language() === "de")
                                {
                                    window.location.search = window.location.search.replace("language=de", "language=en")
                                    eQrCodeForm.setAttribute("action", eQrCodeForm.getAttribute("action").replace("language=de", "language=en"))
                                }
                                else
                                {
                                    window.location.search =  window.location.search.replace("language=en", "language=de")
                                    eQrCodeForm.setAttribute("action", eQrCodeForm.getAttribute("action").replace("language=en", "language=de"))
                                }

                            } else {
                                if(this._language() === "de") {
                                    location.href = "/display.php?di_id=" + this.displayId() + '&language=en';
                                } else {
                                    location.href = "/display.php?di_id=" + this.displayId() + '&language=de';
                                }

                            }
						}
						else
						{
							this.load(oEvent.target.parentElement.id)
						}
					}
				}
			},
			onBodyClicked: function()
			{

				this.focusQrCode()
			},
			onContextMenu: function(oEvent)
			{
				oEvent.preventDefault()
			},
			onLogoClicked: function(oEvent)
			{
				this.reload()
			},
			onTimeUpdate: function()
			{
				this._element("time").textContent = new Date().toLocaleString
				(
					this._language(),
					{
						weekday:	"long"	,
						year:	"numeric"	,
						month:	"long"	,
						day:	"2-digit"	,
						hour:	"2-digit"	,
						minute:	"2-digit"	,
						second:	"2-digit"	,
					}
				)
			},
			onUnload: function()
			{
				this.finalize()
			},
			onWebSocketClose: function()
			{
				this._element("websocketStatus").setAttribute("data-connected", false)
				window.setTimeout(() => {this._websocket(null)}, 60000)
			},
			onWebSocketMessage: function(oMessage)
			{

				oMessage = JSON.parse(oMessage.data)
                

				switch(oMessage.type)
				{
					case "ping":

                        var messageJSON = {

                                    chat_user: this.displayId(),
                                    chat_message: 'pong',
                                    di_id: this.displayId()

                        };
                        this._websocket().send( JSON.stringify(messageJSON) )
                        console.log('got ping message - replaying pong')
						break
                    case "reload":
                        console.log('got reload message - hm.... reloading :-> ')
                        this.reload()
                        break
                    case "evac_full":
                        $("#whole_body").load('/ajax/display_wrapper.php?di_id=' + this.displayId() + '&action=display_alarm_screen_load&type=full');
                        console.log('got evac message - panic! :-o ')

                        break
                    case "evac_small":
                        $("#content").load('/ajax/display_wrapper.php?di_id=' + this.displayId() + '&action=display_alarm_screen_load&type=small');
                        console.log('got evac message - panic! :-o ')

                        break
                    case "amok_full":
                        $("#whole_body").load('/ajax/display_wrapper.php?di_id=' + this.displayId() + '&action=display_amok_screen_load&type=full');
                        console.log('got amok message - panic! :-o ')

                        break
                    case "amok_small":
                        $("#content").load('/ajax/display_wrapper.php?di_id=' + this.displayId() + '&action=display_amok_screen_load&type=small');
                        console.log('got amok message - panic! :-o ')

                        break
                    case "content_load":
                        $("#content").load('/ajax/display_wrapper.php?di_id=' + this.displayId() + '&action=display_screen_content_load&type=small');
                        console.log('loading content into #content area')

                        break
                    case "partymode":
                        $("#content").load('/ajax/display_wrapper.php?di_id=' + this.displayId() + '&action=display_screen_partymode_load&type=small');
                        console.log('loading partymode ... yeah! ')

                        break
                    case "whole_body_load":
                        $("#whole_body").load('/ajax/display_wrapper.php?di_id=' + this.displayId() + '&action=display_screen_whole_body_load&type=small');
                        console.log('loading content into #whole_body area')

                        break
					case "who_are_you":
                        var messageJSON = {
                                    chat_user: this.displayId(),
                                    chat_message: 'my_id_is',
                                    di_id: this.displayId()
                        };

                        this._websocket().send( JSON.stringify(messageJSON) )

                        console.log('sending my di_id ' + this.displayId() + ' to server')

						break
				}
			},
			onWebSocketOpen: function()
			{
				this._element("websocketStatus").setAttribute("data-connected", true);
			},
			// </editor-fold>
			/*
			  ###  ######   #######  ##    ##       ## ########  ######## ###    ######  ######## ########  ##     ##  ######  ########  #######  ########
			 ##   ##    ## ##     ## ###   ##      ##  ##     ## ##         ##  ##    ##    ##    ##     ## ##     ## ##    ##    ##    ##     ## ##     ##
			##    ##       ##     ## ####  ##     ##   ##     ## ##          ## ##          ##    ##     ## ##     ## ##          ##    ##     ## ##     ##
			##    ##       ##     ## ## ## ##    ##    ##     ## ######      ##  ######     ##    ########  ##     ## ##          ##    ##     ## ########
			##    ##       ##     ## ##  ####   ##     ##     ## ##          ##       ##    ##    ##   ##   ##     ## ##          ##    ##     ## ##   ##
			 ##   ##    ## ##     ## ##   ###  ##      ##     ## ##         ##  ##    ##    ##    ##    ##  ##     ## ##    ##    ##    ##     ## ##    ##
			  ###  ######   #######  ##    ## ##       ########  ######## ###    ######     ##    ##     ##  #######   ######     ##     #######  ##     ##
			*/
			// <editor-fold constructor/destructor>
			initialize: function()
			{


				var oQuery

				oQuery = this._query()

				this.onActionClicked	= this.onActionClicked	.bind(this)
				this.onBodyClicked	= this.onBodyClicked	.bind(this)
				this.onContextMenu	= this.onContextMenu	.bind(this)
				this.onLogoClicked	= this.onLogoClicked	.bind(this)
				this.onTimeUpdate	= this.onTimeUpdate	.bind(this)
				this.onUnload		= this.onUnload	.bind(this)
				this.onWebSocketClose	= this.onWebSocketClose	.bind(this)
				this.onWebSocketMessage	= this.onWebSocketMessage	.bind(this)
				this.onWebSocketOpen	= this.onWebSocketOpen	.bind(this)

				this._element("logo"	, document.querySelector("#header #logo"	))
				this._element("time"	, document.querySelector("#footer #time"	))
				this._element("websocketStatus"	, document.querySelector("#footer #websocketStatus"	))

				this._element("logo")	.addEventListener("click"	, this.onLogoClicked	)
				document.body	.addEventListener("contextmenu"	, this.onContextMenu	)
				window	.addEventListener("beforeunload"	, this.onUnload	)

				if(!window.location.search.includes("language="))
				{
					window.location.search += "&language=de"

					return this
				}
				this._language(window.location.search.match(/language=(\S+)/)[1])

                if ( document.querySelector("#banner") ) {
                    this._slider(new window.metasec.Slider(document.querySelector("#banner")))
                }


				// start websocket connection
				this._websocket(null)

				this.onTimeUpdate()
				window.setInterval(this.onTimeUpdate, 1000)

				if(this.isMainPage())
				{


					this	._element("actions"	, document.querySelector("#actions"	))
						._element("qrCode"	, document.querySelector("#qr_code"	))

					this._element("actions")	.addEventListener("click"	, this.onActionClicked	)
					document.body	.addEventListener("click"	, this.onBodyClicked	)

					this.displayId(oQuery.di_id)

                    if ( document.getElementById('qr_engine_type') ) {

                        if ( document.getElementById('qr_engine_type').value == 'hw'  ) {
                            document.querySelector("#qr_time")    .value = Date.now()
                            document.querySelector("#qr_di_id")    .value    = this.displayId()

                            this.focusQrCode()
                        }

                    }
                }

				return this
			},
			finalize:	function()
			{
				if(this.isMainPage())
				{
					this._element("actions").removeEventListener("click"	, this.onActionClicked	)
				}
				this._element("logo"	)	.removeEventListener("click"	, this.onLogoClicked	)
				window		.removeEventListener("beforeunload"	, this.onUnload	)

				return this
			},
			// </editor-fold>
			/*
			##     ## ######## ######## ##     ##  #######  ########   ######
			###   ### ##          ##    ##     ## ##     ## ##     ## ##    ##
			#### #### ##          ##    ##     ## ##     ## ##     ## ##
			## ### ## ######      ##    ######### ##     ## ##     ##  ######
			##     ## ##          ##    ##     ## ##     ## ##     ##       ##
			##     ## ##          ##    ##     ## ##     ## ##     ## ##    ##
			##     ## ########    ##    ##     ##  #######  ########   ######
			*/
			// <editor-fold methods>
			/*
			########  ########  #### ##     ##    ###    ######## ########
			##     ## ##     ##  ##  ##     ##  ##   ##     ##    ##
			########  ########   ##  ##     ## ##     ##    ##    ######
			##        ##   ##    ##   ##   ##  #########    ##    ##
			##        ##     ## ####    ###    ##     ##    ##    ########
			*/
			// <editor-fold private>
			_query: function()
			{
				var oData

				oData = {}

				window.location.search.substr(1).split("&").forEach
				(
					(sPair) =>
					{
						var asPair

						asPair = sPair.split("=")

						oData[asPair[0]] = asPair[1]
					}
				)

				return oData
			},
			// </editor-fold>
			/*
			########  ##     ## ########  ##       ####  ######
			##     ## ##     ## ##     ## ##        ##  ##
			########  ##     ## ########  ##        ##  ##
			##        ##     ## ##     ## ##        ##  ##
			##         #######  ########  ######## ####  ######
			*/
			// <editor-fold public>
			focusQrCode: function()
			{
				if ( document.getElementById('qr_engine_type').value == 'hw'  ) {
                    this._element("qrCode").focus()
                }
				return this
			},
			isMainPage: function()
			{
				return window.location.pathname.includes("display.php")
			},
			load: function(sType)
			{


				var sFunction = "meta_james_display_" + sType + "_load"


				if(typeof window[sFunction] === "function")
				{
					window[sFunction](this.displayId())
				}

				return this
			},
			reload: function()
			{
				if(this.isMainPage())
				{
					window.location.reload()
				}
				else
				{
					window.location.href = this._element("logo").getAttribute("data-link")
				}
			},
			// </editor-fold>
			// </editor-fold>
		}

		document.addEventListener
		(
			"DOMContentLoaded",
			() =>
			{
				oPresenter.initialize()
			}
		)
	}()
)
