(
	function()
	{
		"use strict";

		class Slider
		{
			/*
			  ###  ######         ##  ######  ###   ######## ######## ######## ######## ########
			 ##   ##    ##       ##  ##    ##   ##  ##          ##       ##    ##       ##     ##
			##    ##            ##   ##          ## ##          ##       ##    ##       ##     ##
			##    ##   ####    ##     ######     ## ######      ##       ##    ######   ########
			##    ##    ##    ##           ##    ## ##          ##       ##    ##       ##   ##
			 ##   ##    ##   ##      ##    ##   ##  ##          ##       ##    ##       ##    ##
			  ###  ######   ##        ######  ###   ########    ##       ##    ######## ##     ##
			*/
			// <editor-fold getter/setter>
			/*
			 ######  ########    ###    ######## ####  ######
			##          ##     ##   ##     ##     ##  ##
			 ######     ##    ##     ##    ##     ##  ##
			      ##    ##    #########    ##     ##  ##
			 ######     ##    ##     ##    ##    ####  ######
			*/
			// <editor-fold static>
			static get settings()
			{
				return Object.freeze
				({
					interval:	5000,

					animation:
					{
						duration:	"500ms",
						type:	"slide",
					},

					controls:	["playPause"],
				})
			}
			// </editor-fold>
			/*
			#### ##    ##  ######  ########    ###    ##    ##  ######  ########
			 ##  ####  ## ##          ##     ##   ##  ####  ## ##       ##
			 ##  ## ## ##  ######     ##    ##     ## ## ## ## ##       ######
			 ##  ##  ####       ##    ##    ######### ##  #### ##       ##
			#### ##    ##  ######     ##    ##     ## ##    ##  ######  ########
			*/
			// <editor-fold instance>
			get contentId()
			{
				return this.element.getAttribute("data-next-id")
			}
			get contentObjects()
			{
				return this.oContentObjects
			}
			get contentType()
			{
				return this.element.getAttribute("data-content-type")
			}
			get contentUrl()
			{
				return this.element.getAttribute("data-content-url")
			}
			get displayId()
			{
				return this.sDisplayId
			}
			set displayId(sDisplayId)
			{
				this.sDisplayId = sDisplayId
			}
			get element()
			{
				return this.eElement
			}
			set element(eElement)
			{
				this.eElement = eElement
			}
			get settings()
			{
				return this.oSettings
			}
			set settings(oSettings)
			{
				this.oSettings = $.extend(true, {}, Slider.settings, this.settings, oSettings)
			}
			get timer()
			{
				return this.nTimer
			}
			set timer(nTimer)
			{
				this.nTimer = nTimer
			}
			// </editor-fold>
			// </editor-fold>
			/*
			######## ##     ## ######## ##    ## ########  ######
			##       ##     ## ##       ###   ##    ##    ##    ##
			##       ##     ## ##       ####  ##    ##    ##
			######   ##     ## ######   ## ## ##    ##     ######
			##        ##   ##  ##       ##  ####    ##          ##
			##         ## ##   ##       ##   ###    ##    ##    ##
			########    ###    ######## ##    ##    ##     ######
			*/
			// <editor-fold events>
			onAnimationCompleted()
			{
				this	._switch	()
					._load	()
			}
			onContentClicked(oEvent)
			{
				oEvent.preventDefault()
			}
			onContentLoaded()
			{
				var eNextContent

				eNextContent = this.element.querySelector(".slider-content-next")

				if(this.contentType === "pdf")
				{
					$(eNextContent).append
					(
						$("<iframe />")
							.attr
							(
								"src",
								"/metacore/jslibs/pdfjs/web/viewer.html?file=" +
								encodeURIComponent(this.contentUrl) +
								"#page=1"
							)
							.on
							("load", () => {this.contentObjects.next = eNextContent.querySelector("iframe").contentWindow.PDFViewerApplication})
					)
				}
				else if(this.contentType === "video")
				{
						let eYoutube

						eYoutube	= document.createElement("DIV")

						eNextContent.append(eYoutube)
						window.setTimeout(() =>{
								this.contentObjects.next = new YT.Player
								(
									eYoutube,
									{
										height:	"607"	,
                                        //videoId:    new RegExp(/(?:\?v=|\/)([A-Za-z0-9-_]+)(?:\?[^v]|[&$])/).exec(this.contentUrl)[1]    ,
										videoId:	this.contentUrl,
										width:	"1080",
										events:
										{	
											onReady: onPlayerReady,
											onStateChange: (sState) =>
											{
												if(sState.data === YT.PlayerState.ENDED)
												{
													this.next(false).play()

												}
											},
											onError: (error) =>
											{
												console.log(error);
											},
										},
										playerVars:
										{
											controls:	0	,
											disablekb:	1	,
											enablejsapi:	1	,
											fs:	0	,
											origin:	window.location.hostname	,
											rel:	0	,
											showinfo:	0	,
										},
									}
								)
								
								function onPlayerReady(event) {
								  event.target.setVolume(50);
								  event.target.setPlaybackQuality("hd720");
								}

							}, 1
						)
					
				}
			}
			onContentContextMenu(oEvent)
			{
				oEvent.preventDefault()
			}
			onIntervalElapsed()
			{
				this.next(false)
			}
			onUnload()
			{
				this.destructor()
			}
			// </editor-fold>
			/*
			  ###  ######   #######  ##    ##       ## ########  ######## ###    ######  ######## ########  ##     ##  ######  ########  #######  ########
			 ##   ##    ## ##     ## ###   ##      ##  ##     ## ##         ##  ##    ##    ##    ##     ## ##     ## ##    ##    ##    ##     ## ##     ##
			##    ##       ##     ## ####  ##     ##   ##     ## ##          ## ##          ##    ##     ## ##     ## ##          ##    ##     ## ##     ##
			##    ##       ##     ## ## ## ##    ##    ##     ## ######      ##  ######     ##    ########  ##     ## ##          ##    ##     ## ########
			##    ##       ##     ## ##  ####   ##     ##     ## ##          ##       ##    ##    ##   ##   ##     ## ##          ##    ##     ## ##   ##
			 ##   ##    ## ##     ## ##   ###  ##      ##     ## ##         ##  ##    ##    ##    ##    ##  ##     ## ##    ##    ##    ##     ## ##    ##
			  ###  ######   #######  ##    ## ##       ########  ######## ###    ######     ##    ##     ##  #######   ######     ##     #######  ##     ##
			*/
			// <editor-fold constructor/destructor>
			constructor(eElement, oSettings)
			{
				var oQuery

				oQuery = this._query()

				this.sDisplayId	= null
				this.eElement	= null
				this.nTimer	= null

				this.oContentObjects	= {current: null, next: null}
				this.oSettings	=	{}

				this.element	= eElement
				this.displayId	= oQuery.di_id
				this.settings	= oSettings

				this.onAnimationCompleted	= this.onAnimationCompleted	.bind(this)
				this.onContentClicked	= this.onContentClicked	.bind(this)
				this.onContentLoaded	= this.onContentLoaded	.bind(this)
				this.onIntervalElapsed	= this.onIntervalElapsed	.bind(this)
				this.onUnload	= this.onUnload	.bind(this)

				this.element.addEventListener("contextmenu", this.onContentContextMenu)
				window.addEventListener("beforeunload", this.onUnload)

				this	._create()
					._load(1)
				window.setTimeout
				(
					() =>
					{
						//this.element = Array.prototype.slice.call(document.querySelectorAll(".slider")).find((eElement) => {return this.element.isSameNode(eElement)})
						this	.next(false)
							.play()
					}
				)

				return this
			}
			destructor()
			{
				this._destroy()
			}
			// </editor-fold>
			/*
			##     ## ######## ######## ##     ##  #######  ########   ######
			###   ### ##          ##    ##     ## ##     ## ##     ## ##    ##
			#### #### ##          ##    ##     ## ##     ## ##     ## ##
			## ### ## ######      ##    ######### ##     ## ##     ##  ######
			##     ## ##          ##    ##     ## ##     ## ##     ##       ##
			##     ## ##          ##    ##     ## ##     ## ##     ## ##    ##
			##     ## ########    ##    ##     ##  #######  ########   ######
			*/
			// <editor-fold methods>
			/*
			########  ########  #### ##     ##    ###    ######## ########
			##     ## ##     ##  ##  ##     ##  ##   ##     ##    ##
			########  ########   ##  ##     ## ##     ##    ##    ######
			##        ##   ##    ##   ##   ##  #########    ##    ##
			##        ##     ## ####    ###    ##     ##    ##    ########
			*/
			// <editor-fold private>
			_create()
			{
				var	eCurrentElement	,
					oDocumentFragment	,
					eParentElement

				this.element.classList.add("slider")
				oDocumentFragment = document.createDocumentFragment()
				eParentElement = oDocumentFragment
				eCurrentElement = document.createElement("DIV")
				eCurrentElement.classList.add("slider-content")
				eCurrentElement.addEventListener("click", this.onContentClicked)
				eParentElement.appendChild(eCurrentElement)
				eParentElement = eCurrentElement
				eCurrentElement = document.createElement("DIV")
				eCurrentElement.classList.add("slider-content-current")
				eParentElement.appendChild(eCurrentElement)
				eCurrentElement = document.createElement("DIV")
				eCurrentElement.classList.add("slider-content-next")
				eCurrentElement.addEventListener("animationend", this.onAnimationCompleted)
				eParentElement.appendChild(eCurrentElement)
				eParentElement = oDocumentFragment
				if(this.settings.controls.length > 0)
				{
					eCurrentElement = document.createElement("DIV")
					eCurrentElement.classList.add("slider-controls")
					eParentElement.appendChild(eCurrentElement)
					/*this.settings.controls.forEach
					(
						(sControl) =>
						{

						}
					)*/
				}
				this.element.appendChild(oDocumentFragment)

				return this
			}
			_destroy()
			{
				this.element.classList.remove("slider")
				Array.prototype.slice.call(this.element.children).forEach((eElement) => {eElement.remove()})

				return this
			}
			_load(nId)
			{
				if(nId === undefined)
				{
					nId = window.parseInt(this.contentId)
				}
				if(this.contentType !== "pdf" || this.contentObjects.current.page === this.contentObjects.current.pagesCount)
				{
					meta_james_display_load_slider_content(this.displayId, nId, this.onContentLoaded)
				}

				return this
			}
			_query()
			{
				var oData

				oData = {}

				window.location.search.substr(1).split("&").forEach
				(
					(sPair) =>
					{
						var asPair

						asPair = sPair.split("=")

						oData[asPair[0]] = asPair[1]
					}
				)

				return oData
			}
			_switch()
			{
				var	eCurrentContent,
					eNextContent

				eCurrentContent = this.element.querySelector(".slider-content-current")
				eNextContent = this.element.querySelector(".slider-content-next")

				//eCurrentContent.classList.remove("animate", this.settings.animation.type + "Out", "left")
				//eNextContent.classList.remove("animate", this.settings.animation.type + "In", "left")
				if(this.contentType === "image" ||this.contentType === "video" || !this.element.querySelector(".slider-content-current iframe"))
				{
					this.contentObjects.current	= this.contentObjects.next
					this.contentObjects.next	= null

					eCurrentContent.classList.add("slider-content-next")
					eCurrentContent.classList.remove("slider-content-current")
					eNextContent.classList.add("slider-content-current")
					eNextContent.classList.remove("slider-content-next")

					if(this.contentType === "pdf")
					{
						window.setTimeout(() => {this.contentObjects.current.pdfViewer._setScale("page-fit")})
					}
					else if(this.contentType === "video")
					{
						this.pause()
						window.setTimeout(() => {this.contentObjects.current.playVideo()})
					}
				}
				else if(this.contentType === "pdf")
				{
					this.contentObjects.current.page = ++this.contentObjects.current.page
				}

				return this
			}
			// </editor-fold>
			/*
			########  ##     ## ########  ##       ####  ######
			##     ## ##     ## ##     ## ##        ##  ##
			########  ##     ## ########  ##        ##  ##
			##        ##     ## ##     ## ##        ##  ##
			##         #######  ########  ######## ####  ######
			*/
			// <editor-fold public>
			isRunning()
			{
				return this.timer !== null
			}
			next( bAnimate = true )
			{
				if(bAnimate)
				{
					//this.element.children[0].children[0].classList.add("animate", this.settings.animation.type + "Out", "left")
					//this.element.children[0].children[1].classList.add("animate", this.settings.animation.type + "In", "left")
				}
				else
				{
					this.onAnimationCompleted()
				}

				return this
			}
			pause()
			{
				if(this.isRunning())
				{
					window.clearInterval(this.timer)
					this.timer = null;
				}

				return this
			}
			play()
			{
				if(!this.isRunning())
				{
					this.timer = window.setInterval(this.onIntervalElapsed, this.settings.interval)
				}

				return this
			}
			// </editor-fold>
			// </editor-fold>
		}

		if(window.metasec === undefined)
		{
			window.metasec = {}
		}
		window.metasec.Slider = Slider
	}()
)
