#!/bin/bash
 
set -e

backupPath="/tmp/nginxBackup/$(date +%s)"
 
nginxConfigDir=/usr/share/metasec_core/sampledata/ngnix
phpDir=/usr/share/metasec_core/sampledata/php5/fpm/*
 
echo "Do you want to use the default james-nginx configurations (this will overwrite your own cofigurations)? Type y/n"
read nginxConf

if [ "$nginxConf" == "y" ]; then
	echo "create backup: $backupPath"
	mkdir -p $backupPath
	cp -R /etc/nginx/* $backupPath/nginx
	cp -R /etc/php/7.0/fpm/* $backupPath/php7.0-fpm
	echo "copy james default nginx files"
	cp -R ${nginxConfigDir}/* /etc/nginx/
	
	cp -rf $phpDir /etc/php/7.0/fpm/
	
fi

echo "Do you want to create a ssl certificate Type y/n"

read sslCert

if [ "$sslCert" == "y" ]; then
	/bin/bash /usr/share/metasec_core/scripts/mk_ssl_cert.sh
fi

/etc/init.d/nginx restart
/etc/init.d/php7.0-fpm restart

echo "Setup finished"
