## openapi-spec

Using swagger-php to generate the [examples in the spec](https://github.com/OAI/OpenAPI-Specification/tree/master/examples/v3.0)

## petstore.swagger.io

Using swagger-php to generate the [example for swagger-ui](http://petstore.swagger.io/)

## swagger-spec

Using swagger-php to generate the [examples in the spec](https://github.com/swagger-api/swagger-spec/tree/master/examples/v3.0)

### petstore
The smallest example, contains only 1 operation.

[json](../tests/ExamplesOutput/petstore.json)
[folder](swagger-spec/petstore)

### petstore-simple
An example with 4 operations on 2 paths.

[json](../tests/ExamplesOutput/petstore-simple.json)
[folder](swagger-spec/petstore-simple)

### petstore-with-external-docs
Very similar to petstore-simple but with externalDocs

[json](../tests/ExamplesOutput/petstore-with-external-docs.json)
[folder](swagger-spec/petstore-with-external-docs)

### openapi-spec
Simple example with 3 models and 3 actions

[json](../tests/ExamplesOutput/openapi-spec.json)
[folder](openapi-spec)

### petstore.swagger.io
Demonstration for petstore.swagger.io in php swagger annotations

[json](../tests/ExamplesOutput/openapi-spec.json)
[folder](openapi-spec)

## using-refs
Example demonstrating different use-cases of $ref to keep your documentation [D.R.Y.](https://en.wikipedia.org/wiki/Don%27t_repeat_yourself)

[json](../tests/ExamplesOutput/using-refs.json)
[folder](using-refs)
